<?php
  /*
  version = 1.04
  Matiou
  
  Parsing depuis l'adresse IPVERA:3480/data_request?id=lu_sdata
  
  le but est de renseigner juste L'IP et L'"ID" du module et il extrait la valeur de la variable principale.
  Exemple: pour une sonde de température il renvera la valeur de 'temperature', pour cela je me base sur la categorie du module.
      {  
         "name":"ST Exterieur",
         "altid":"TS\/TH1\/45313",
         "id":116,
         "category":17,
         "subcategory":0,
         "room":8,
         "parent":26,
         "batterylevel":"100",
         "temperature":"18"
      },
      

  Il est possible d'extraire une autre variable en renseignant "var"
  on peut connaitre la variable en ouvrant ouvrant le fichier et en le reformatant a travers le site suivant
  
  http://jsonformatter.curiousconcept.com/
  
  Exemple pour mon compteur:
  
        {  
         "name":"PW General",
         "altid":"PM\/ELEC2\/54178",
         "id":27,
         "category":21,
         "subcategory":0,
         "room":8,
         "parent":26,
         "batterylevel":"100",
         "kwh":"8417",
         "watts":"482"
      },
      
  avec le simple ID le script resort la puissance mais en ajoutant 'var=kwh' on a l'energie.
  ParseVERAjson.php IP=XXX.XXX.XXX.XXX ID=47 var=kwh
  
  ainsi on peut extraire toute les variables et surveiller les batteries ;p
  
  */


if (isset($argv)) {
  foreach ($argv as $arg) {
    $argList = explode('=', $arg);
    if (isset($argList[0]) && isset($argList[1])) {
      $_GET[$argList[0]] = $argList[1];
    }
  }
}

$adr = $_GET['IP'];
$getid = $_GET['ID'];

if (isset($_GET['var'])) {
	$variable = $_GET['var'];
} else {
    $variable = "";
}

// Création du dossier tmp si il existe pas
$tmp = 'tmp';
if(!is_dir($tmp)){
   mkdir($tmp);
}

// déclarations des variables
$chemin = dirname(__FILE__).'/tmp/'; //chemin ou enregistrer le fichier json
$filename = 'vera.json'; //Nom du fichier
$cmd = "wget -O " . $chemin . $filename . " -q http://" . $adr . ":3480/data_request?id=lu_sdata";

// On regarde si le fichier est plus vieux de Xs
if (file_exists($filename)) {
  $datefichier = date ("U", filemtime($filename));
	if ((time() - $datefichier) > 30) {
	  exec($cmd);
	}
} else {
  exec($cmd);
}

// On commence a Parser
$json = file_get_contents($chemin .  $filename);
$parsed_json = json_decode($json);

$i=0;

while ($i <= 100) {
  $TestId = $parsed_json->{'devices'}[$i]->{'id'};
  
  switch (json_last_error()) {
    
	case JSON_ERROR_NONE:
		//echo ' - Aucune erreur';
		break;
	case JSON_ERROR_DEPTH:
		echo ' - Profondeur maximale atteinte';
		break;
	case JSON_ERROR_STATE_MISMATCH:
		echo ' - Inadéquation des modes ou underflow';
		break;
	case JSON_ERROR_CTRL_CHAR:
		echo ' - Erreur lors du contrôle des caractères';
		break;
	case JSON_ERROR_SYNTAX:
      	echo ' - Erreur de syntaxe ; JSON malformé';
		break;
	case JSON_ERROR_UTF8:
		echo ' - Caractères UTF-8 malformés, probablement une erreur d\'encodage';
		break;
	default:
		echo ' - Erreur inconnue';
		break;
  }
  
  if ($getid == $TestId) {
	  $CaseId = $i;
	  $i=100;
      break;
  }
  $i++;
}

if ($i < 101) {
  $Categorie = $parsed_json->{'devices'}[$CaseId]->{'category'};

  if ($variable == "") {
    if ($Categorie == 2)  //DIMMABLE_LIGHT
      $variable = "level";
    if ($Categorie == 3)  //SWITCH
      $variable = "status";
    if ($Categorie == 4)  //SECURITY_SENSOR
       $variable = "tripped";
    if ($Categorie == 12) //GENERIC_SENSOR
      $variable = "light";
    if ($Categorie == 16) //HUMIDITY
      $variable = "humidity";
    if ($Categorie == 17) //TEMPERATURE
      $variable = "temperature";
    if ($Categorie == 21) //POWER_METER
      $variable = "watts";
  }
  echo $parsed_json->{'devices'}[$CaseId]->{$variable}; //Valeur
} else {
  echo "L'id n'est pas bon";
}


  
/* Pour le Debug
echo "<br>Numero de la case : ${CaseId}";

$Categorie = $parsed_json->{'devices'}[$CaseId]->{'category'};
 echo "<br>La categorie : ${Categorie}<br>";
*/
/*
define DEVICE_CATEGORY_INTERFACE       1
define DEVICE_CATEGORY_DIMMABLE_LIGHT  2
define DEVICE_CATEGORY_SWITCH          3
define DEVICE_CATEGORY_SECURITY_SENSOR 4
define DEVICE_CATEGORY_HVAC            5
define DEVICE_CATEGORY_CAMERA          6
define DEVICE_CATEGORY_DOOR_LOCK       7
define DEVICE_CATEGORY_WINDOW_COV      8
define DEVICE_CATEGORY_REMOTE_CONTROL  9
define DEVICE_CATEGORY_IR_TX           10
define DEVICE_CATEGORY_GENERIC_IO      11
define DEVICE_CATEGORY_GENERIC_SENSOR  12
define DEVICE_CATEGORY_SERIAL_PORT     13
define DEVICE_CATEGORY_SCENE_CONTROLLER 14
define DEVICE_CATEGORY_AV              15
define DEVICE_CATEGORY_HUMIDITY        16
define DEVICE_CATEGORY_TEMPERATURE     17
define DEVICE_CATEGORY_LIGHT_SENSOR    18
define DEVICE_CATEGORY_ZWAVE_INT       19
define DEVICE_CATEGORY_INSTEON_INT     20
define DEVICE_CATEGORY_POWER_METER     21
define DEVICE_CATEGORY_ALARM_PANEL     22
define DEVICE_CATEGORY_ALARM_PARTITION 23
define DEVICE_CATEGORY_SIREN           24
*/

?>